public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Alfredo Tupone" <tupone@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-lang/gnat-gpl/
Date: Sun, 27 Feb 2022 08:19:10 +0000 (UTC)	[thread overview]
Message-ID: <1645949925.43a23abf9991a3df50f521acd49ebba60ff60c88.tupone@gentoo> (raw)

commit:     43a23abf9991a3df50f521acd49ebba60ff60c88
Author:     Alfredo Tupone <tupone <AT> gentoo <DOT> org>
AuthorDate: Sun Feb 27 08:18:45 2022 +0000
Commit:     Alfredo Tupone <tupone <AT> gentoo <DOT> org>
CommitDate: Sun Feb 27 08:18:45 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=43a23abf

dev-lang/gnat-gpl: gcc slot from 10 is only the major

Closes: https://bugs.gentoo.org/833779
Package-Manager: Portage-3.0.30, Repoman-3.0.3
Signed-off-by: Alfredo Tupone <tupone <AT> gentoo.org>

 dev-lang/gnat-gpl/gnat-gpl-2021-r2.ebuild | 146 ++++++++++++++++++++++++++++++
 1 file changed, 146 insertions(+)

diff --git a/dev-lang/gnat-gpl/gnat-gpl-2021-r2.ebuild b/dev-lang/gnat-gpl/gnat-gpl-2021-r2.ebuild
new file mode 100644
index 000000000000..1ac2e777e3ed
--- /dev/null
+++ b/dev-lang/gnat-gpl/gnat-gpl-2021-r2.ebuild
@@ -0,0 +1,146 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PATCH_GCC_VER=10.3.0
+PATCH_VER="3"
+
+TOOLCHAIN_GCC_PV=10.3.1
+
+REL=10
+MYP=gcc-${REL}-${PV}-20210519-19A74-src
+GNATDIR=gnat-${PV}-20210519-19A70-src
+INTFDIR=gcc-interface-${REL}-${PV}-20210519-19A75-src
+
+BTSTRP_X86=gnat-gpl-2014-x86-linux-bin
+BTSTRP_AMD64=gnat-gpl-2014-x86_64-linux-bin
+BASE_URI=https://community.download.adacore.com/v1
+# we provide own tarball below
+GCC_TARBALL_SRC_URI="
+	${BASE_URI}/005d2b2eff627177986d2517eb31e1959bec6f3a?filename=${GNATDIR}.tar.gz
+		-> ${GNATDIR}.tar.gz
+	${BASE_URI}/44cd393be0b468cc253bf2cf9cf7804c993e7b5b?filename=${MYP}.tar.gz
+		-> ${MYP}.tar.gz
+	${BASE_URI}/8ace7d06e469d36d726cc8badb0ed78411e727f3?filename=${INTFDIR}.tar.gz
+		-> ${INTFDIR}.tar.gz
+	bootstrap? (
+		amd64? (
+			${BASE_URI}/6eb6eef6bb897e4c743a519bfebe0b1d6fc409c6?filename=${BTSTRP_AMD64}.tar.gz&rand=1193
+			-> ${BTSTRP_AMD64}.tar.gz
+		)
+		x86? (
+			${BASE_URI}/c5e9e6fdff5cb77ed90cf8c62536653e27c0bed6?filename=${BTSTRP_X86}.tar.gz&rand=436
+			-> ${BTSTRP_X86}.tar.gz
+		)
+	)"
+
+inherit toolchain-funcs toolchain
+
+DESCRIPTION="GNAT Ada Compiler - GPL version"
+HOMEPAGE="http://libre.adacore.com/"
+
+LICENSE+=" GPL-2 GPL-3"
+KEYWORDS="~amd64 ~x86"
+IUSE="+ada +bootstrap"
+RESTRICT="test"
+
+RDEPEND="!~sys-devel/gcc-${GCCMAJOR}"
+BDEPEND=sys-devel/binutils
+
+S="${WORKDIR}"/${MYP}
+
+src_unpack() {
+	if ! use bootstrap && [[ -z "$(type ${GNATMAKE} 2>/dev/null)" ]] ; then
+		eerror "You need a gcc compiler that provides the Ada Compiler:"
+		eerror "1) use gcc-config to select the right compiler or"
+		eerror "2) set the bootstrap use flag"
+		die "ada compiler not available"
+	fi
+
+	toolchain_src_unpack
+}
+
+src_prepare() {
+	if use amd64; then
+		BTSTRP=${BTSTRP_AMD64}
+	else
+		BTSTRP=${BTSTRP_X86}
+	fi
+
+	if use bootstrap; then
+		GCC="${WORKDIR}"/${BTSTRP}/bin/gcc
+	else
+		GCC=${ADA:-$(tc-getCC)}
+	fi
+
+	gnatbase=$(basename ${GCC})
+	gnatpath=$(dirname ${GCC})
+
+	GNATMAKE=${gnatbase/gcc/gnatmake}
+	if [[ ${gnatpath} != "." ]] ; then
+		GNATMAKE="${gnatpath}/${GNATMAKE}"
+	fi
+	if use bootstrap; then
+		rm "${WORKDIR}"/${BTSTRP}/libexec/gcc/x86_64-pc-linux-gnu/4.7.4/ld \
+			|| die
+		ln -s /usr/bin/$CHOST-ld \
+			"${WORKDIR}"/${BTSTRP}/libexec/gcc/x86_64-pc-linux-gnu/4.7.4/ld \
+			|| die
+		rm "${WORKDIR}"/${BTSTRP}/libexec/gcc/x86_64-pc-linux-gnu/4.7.4/as \
+			|| die
+		ln -s /usr/bin/$CHOST-as \
+			"${WORKDIR}"/${BTSTRP}/libexec/gcc/x86_64-pc-linux-gnu/4.7.4/as \
+			|| die
+	fi
+
+	CC=${GCC}
+	CXX="${gnatbase/gcc/g++}"
+	GNATBIND="${gnatbase/gcc/gnatbind}"
+	GNATLINK="${gnatbase/gcc/gnatlink}"
+	GNATLS="${gnatbase/gcc/gnatls}"
+	if [[ ${gnatpath} != "." ]] ; then
+		CXX="${gnatpath}/${CXX}"
+		GNATBIND="${gnatpath}/${GNATBIND}"
+		GNATLINK="${gnatpath}/${GNATLINK}"
+		GNATLS="${gnatpath}/${GNATLS}"
+	fi
+	mkdir bin || die
+	ln -s $(which ${GCC}) bin/gcc || die
+	ln -s $(which ${CXX}) bin/g++ || die
+	ln -s $(which ${GNATMAKE}) bin/gnatmake || die
+	ln -s $(which ${GNATBIND}) bin/gnatbind || die
+	ln -s $(which ${GNATLINK}) bin/gnatlink || die
+	ln -s $(which ${GNATLS}) bin/gnatls || die
+
+	cd ..
+	mv ${GNATDIR}/src/ada ${MYP}/gcc/ || die
+	mv ${INTFDIR} ${MYP}/gcc/ada/gcc-interface || die
+	eapply "${FILESDIR}"/${P}-gentoo.patch
+	cd -
+	sed -i \
+		-e 's:-fcf-protection":":' \
+		libiberty/configure \
+		lto-plugin/configure || die
+	sed -i \
+		-e 's:$(P) ::g' \
+		gcc/ada/gcc-interface/Makefile.in \
+		|| die "sed failed"
+	toolchain_src_prepare
+}
+
+src_configure() {
+	export PATH=${PWD}/bin:${PATH}
+	downgrade_arch_flags "$(gcc-version)"
+	toolchain_src_configure
+}
+
+pkg_postinst() {
+	toolchain_pkg_postinst
+	einfo "This provide the GNAT compiler with gcc for ada/c/c++ and more"
+	einfo "The compiler binary is ${CTARGET}-gcc-${TOOLCHAIN_GCC_PV}"
+	einfo "Even if the c/c++ compilers are using almost the same patched"
+	einfo "source as the sys-devel/gcc package its use is not extensively"
+	einfo "tested, and not supported for updating your system, except for ada"
+	einfo "related packages"
+}


             reply	other threads:[~2022-02-27  8:19 UTC|newest]

Thread overview: 82+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-02-27  8:19 Alfredo Tupone [this message]
  -- strict thread matches above, loose matches on Subject: below --
2024-10-02  0:53 [gentoo-commits] repo/gentoo:master commit in: dev-lang/gnat-gpl/ Sam James
2024-09-29  0:18 Sam James
2024-09-18 15:55 Sam James
2024-09-18 15:51 Sam James
2024-05-09 23:29 Sam James
2024-03-13 19:23 Alfredo Tupone
2024-03-05 10:54 Alfredo Tupone
2024-03-02 16:24 Alfredo Tupone
2024-01-12 11:08 Sam James
2022-12-15 22:27 Alfredo Tupone
2022-11-29 17:33 Alfredo Tupone
2022-11-16 13:17 Alfredo Tupone
2022-11-14  9:49 Joonas Niilola
2022-11-13  8:56 Alfredo Tupone
2022-11-07 17:50 Alfredo Tupone
2022-11-06  8:10 Agostino Sarubbo
2022-10-07 18:38 Alfredo Tupone
2022-09-30 16:51 Alfredo Tupone
2022-02-28 10:46 Alfredo Tupone
2022-01-30 11:02 Alfredo Tupone
2022-01-03 17:11 Alfredo Tupone
2021-12-26 18:15 Jakov Smolić
2021-12-26 17:52 Jakov Smolić
2021-12-19 22:09 Agostino Sarubbo
2021-12-18 21:50 Alfredo Tupone
2021-12-17 13:06 Alfredo Tupone
2021-11-27 20:39 Sam James
2021-11-27 20:15 Sam James
2021-11-10  1:00 Sam James
2021-11-09 21:14 Alfredo Tupone
2021-07-20 16:56 Alfredo Tupone
2021-07-20  6:33 Agostino Sarubbo
2021-05-30 13:46 Alfredo Tupone
2021-05-19 17:34 Alfredo Tupone
2021-05-12 19:47 Alfredo Tupone
2020-06-12 17:18 Alfredo Tupone
2020-06-12  7:55 Agostino Sarubbo
2020-06-12  7:51 Agostino Sarubbo
2020-06-10 20:46 Alfredo Tupone
2020-04-13 11:20 Alfredo Tupone
2020-04-12 16:36 Alfredo Tupone
2020-04-04 19:17 Alfredo Tupone
2020-02-03 20:07 Alfredo Tupone
2019-11-25 21:30 Alfredo Tupone
2019-11-23 17:52 Alfredo Tupone
2019-11-23  8:13 Alfredo Tupone
2019-11-22 12:03 Alfredo Tupone
2019-11-21 21:09 Alfredo Tupone
2019-11-06 19:40 Alfredo Tupone
2019-10-03 18:53 Alfredo Tupone
2019-09-16  6:26 Alfredo Tupone
2019-09-15 14:55 Michał Górny
2019-09-15 14:55 Michał Górny
2019-07-27  6:48 Alfredo Tupone
2019-07-26 21:03 Alfredo Tupone
2019-05-28  6:22 Alfredo Tupone
2019-05-28  6:21 Alfredo Tupone
2019-04-20 20:21 Alfredo Tupone
2018-12-19  7:01 Alfredo Tupone
2018-11-18 21:05 Alfredo Tupone
2018-11-17 14:10 Alfredo Tupone
2018-11-07  6:55 Alfredo Tupone
2018-10-31 13:56 Alfredo Tupone
2018-10-09  6:30 Alfredo Tupone
2018-07-30  6:12 Alfredo Tupone
2018-06-25 10:37 Alfredo Tupone
2018-06-25  7:39 Alfredo Tupone
2018-04-21  7:52 Alfredo Tupone
2018-04-20  6:24 Alfredo Tupone
2018-02-26 17:45 Alfredo Tupone
2018-02-25 14:26 Alfredo Tupone
2017-12-31 14:14 Alfredo Tupone
2017-11-26 18:36 Alfredo Tupone
2017-11-25 20:38 Alfredo Tupone
2017-09-16  9:25 Sergei Trofimovich
2017-06-20  7:47 Alfredo Tupone
2017-05-24 20:50 Alfredo Tupone
2017-05-09 19:43 Alfredo Tupone
2017-03-19 15:35 Alfredo Tupone
2017-03-19  9:49 Alfredo Tupone
2017-03-16  8:27 Alfredo Tupone

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1645949925.43a23abf9991a3df50f521acd49ebba60ff60c88.tupone@gentoo \
    --to=tupone@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox